## dmtcp 1.2.1

=== mtcp/Makefile ===
#+++2006-05-03
##    Copyright (C) 2006  Mike Rieker, Beverly, MA USA
##    Additions by Gene Cooperman to work with x86-64 architecture
##    EXPECT it to FAIL when someone's HeALTh or PROpeRTy is at RISk
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; version 2 of the License.
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##---2006-05-03

##################################################################################################################################
##																##
##  Compile and link the shareable, restore utility and test programs								##
##																##
##  Versions tested with:													##
##    binutils-2.15.92, 2.16.1, 2.18.1, 2.19.1											##
##    glibc-2.3.4, 2.3.6, 2.7.12, 2.7, 2.9											##
##    linux-2.6.9-34, 2.6.9-78, 2.6.10, 2.6.14, 2.6.25, 2.6.26									##
##    gcc-3.4.4, 4.0.2, 4.1.3, 4.3.2												##
##																##
##################################################################################################################################

MTCP_VERSION = 77

# EXPERIMENTAL FEATURE:  checkpointing 32-bit images on 64-bit machines:
# Invoke as "make M32=1" to create 32-bit image on 64-bit machine.
# NOTE:  This also requires a modified HIGHEST_VA in mtcp_internal.h.  WHY?

# If we're running under linux32 on a 64-bit O/S, set mixed mode:  M32=1
ifneq (${shell uname -m},x86_64)
ifeq (${shell setarch x86_64 uname -m 2>/dev/null},x86_64)
M32=1
endif
endif

ifdef M32
# HIGHEST_VA is [vdso] (just above [stack])
CC = gcc -m32 -Wa,--32 -DHIGHEST_VA=0xffffe000
UNAME = linux32 uname
LD_RAW = ld -m32 -melf_i386
LDFLAGS =  -Wl,-m32 -Wl,-melf_i386 -shared
AS = as
else
CC = gcc
UNAME = uname
LD_RAW = ld
LDFLAGS =  -shared
AS = as --32
endif

#Currently sometimes can't link libmtcp.so without CFLAGS=-O0
CFLAGS += -O0 -g
#CFLAGS = -O0 -g -DDEBUG -DTIMING -Wall
# CFLAGS = -O0 -g -DDMTCP_DEBUG -DTIMING -Wall
# Try:  env CFLAGS=-DTEST_FORKED_CHECKPOINTING to CFLAGS  make
#  	 to enable standalone invocation of forked checkpointing.
# Could add something like -Wl,-soname,libmtcp.so.1 if one wants to globally
#  install a copy of libmtcp.so for others to use.

# If ./configure --enable-ptrace-support defined, DMTCP 'make' will set this.
# If calling 'make' from mtcp subdir, you may want to unconditionally set this.
ifdef PTRACE_SUPPORT
  CFLAGS += -DPTRACE
endif

LD = ${CC}
ASFLAGS =
MTCP_DIR := $(shell pwd)

# There might be a 32-bit built system running on top of 32/64 bit capable
# kernel. In that case `uname -m` returns 'x86_64' which is not correct.
# Instead, we should deduce the build-type from the build toochain itself.
ifeq (${shell ${LD_RAW} -shared -verbose|grep OUTPUT_FORMAT|cut -d '"' -f2},elf64-x86-64)
  BUILDTYPE=x86_64
else
  BUILDTYPE=i386
endif

# But for testmtcp, don't use CFLAGS if don't want position-independent code
ifeq ($(BUILDTYPE),x86_64)
  CFLAGS += -fPIC -DPIC
  LDFLAGS += -fPIC 
endif

all default: build tests readmtcp

readmtcp: readmtcp.c
	${CC} ${CFLAGS} -o readmtcp readmtcp.c

build: libmtcp.so mtcp_restart
tests: build testmtcp testmtcp2 testmtcp3 testmtcp4 testmtcp5 threadtest bigtestmtcp

# Test programs

testmtcp: testmtcp.o libmtcp.so
	env LD_LIBRARY_PATH=. ${CC} $(CFLAGS) -o testmtcp testmtcp.o -Wl,--export-dynamic libmtcp.so
	# libtool --mode=link gcc -o testmtcp testmtcp.o -Wl,--export-dynamic libmtcp.so

bigtestmtcp: bigtestmtcp.o libmtcp.so
	env LD_LIBRARY_PATH=. ${CC} $(CFLAGS) -o bigtestmtcp bigtestmtcp.o -Wl,--export-dynamic libmtcp.so

testgettimeofday: testgettimeofday.o libmtcp.so
	env LD_LIBRARY_PATH=. ${CC} $(CFLAGS) \
	  -o testgettimeofday testgettimeofday.o -Wl,--export-dynamic libmtcp.so
testgettimeofday.o: testgettimeofday.c
	${CC} $(CFLAGS) -c -o testgettimeofday.o testgettimeofday.c
checkgettimeofday: libmtcp.so mtcp_restart testgettimeofday
	(sleep 5; pkill testgettimeofda) &
	env LD_LIBRARY_PATH=. ./testgettimeofday || true
	@ echo ""
	@ echo Successfully killed after checkpoint.  Will now restart.
	sleep 2
	(sleep 5; pkill mtcp_restart) &
	./mtcp_restart testgettimeofday.mtcp || true
	@ echo Kill this program now after being satisfied it still works.
	@ echo ""
	sleep 2
	./mtcp_restart testgettimeofday.mtcp

testmtcp.o: testmtcp.c
	${CC} $(CFLAGS) -c -o testmtcp.o testmtcp.c

testmtcp2: testmtcp2.c libmtcp.so
	${CC} $(CFLAGS) -o testmtcp2 testmtcp2.c libmtcp.so

testmtcp3: testmtcp3.c libmtcp.so
	${CC} $(CFLAGS) -o testmtcp3 testmtcp3.c libmtcp.so -lpthread -Xlinker -Map -Xlinker testmtcp3.map

testmtcp4: testmtcp4.c libmtcp.so
	${CC} $(CFLAGS) -o testmtcp4 testmtcp4.c libmtcp.so -lpthread -Xlinker -Map -Xlinker testmtcp4.map

testmtcp5: testmtcp5.c libmtcp.so
	${CC} $(CFLAGS) -o testmtcp5 testmtcp5.c libmtcp.so 

testmtcp6: testmtcp6.c libmtcp.so
	${CC} $(CFLAGS) -Wl,--export-dynamic -o testmtcp6 testmtcp6.c libmtcp.so \
	  -lreadline -lhistory -lcurses

threadtest: threadtest.c
	${CC} $(CFLAGS) -o threadtest threadtest.c

# This is the command-line utility to restore a process


mtcp_restart: mtcp_restart.c mtcp_internal.h mtcp_maybebpt.o \
	mtcp_find_executable.o mtcp_printf.o mtcp_readhexetc.o \
	mtcp_safemmap.o mtcp_state.o mtcp_safe_open.o \
	mtcp_check_vdso.o
	${CC} $(CFLAGS) -static \
	 -o mtcp_restart mtcp_restart.c mtcp_maybebpt.o mtcp_find_executable.o \
	 mtcp_printf.o mtcp_readhexetc.o mtcp_safemmap.o \
	 mtcp_state.o mtcp_safe_open.o mtcp_check_vdso.o -lpthread

#not used:
# # mtcp_restart.so is used only by dmtcp --- not by mtcp
# mtcp_restart.so: mtcp_restart.c mtcp_internal.h mtcp_maybebpt.o mtcp_find_executable.o mtcp_printf.o mtcp_safe_open.o mtcp_readhexetc.o mtcp_safemmap.o mtcp_state.o
# 	# ${CC} $(CFLAGS) -shared -Wl,--no-allow-shlib-undefined
# 	${CC} $(CFLAGS) -shared \
# 	 -o mtcp_restart.so mtcp_restart.c mtcp_maybebpt.o mtcp_find_executable.o \
# 	 mtcp_printf.o mtcp_readhexetc.o mtcp_safemmap.o mtcp_state.o \
# 	 mtcp_safe_open.o

# This is the shareable that a user links with the application

# mtcp.t originally generated as below via:  ld -shared --verbose.
# It was modified to include shareable_begin/end sections.
# The patch was then created with:  diff -c mtcp.t mtcp.tnew > mtcp.t.patch
# Do not replace ld by ${LD} ${LDFLAGS} in generating mtcp.t.
mtcp.t: mtcp.t.patch-i386 mtcp.t.patch-x86_64
	rm -f mtcp.t
	${LD_RAW} -shared --verbose > mtcp.t
	sed -i -e '1,/========================/ d' mtcp.t
	sed -i -e '/========================/,$$ d' mtcp.t
	rm -f mtcp.t-fail
	if test ${BUILDTYPE} = x86_64; then \
	  if patch mtcp.t mtcp.t.patch-x86_64; then \
	    :; \
	  else \
	    mv mtcp.t mtcp.t-fail; false; \
	  fi \
	else \
	  if patch mtcp.t mtcp.t.patch-i386; then \
	    :; \
	  else \
	    mv mtcp.t mtcp.t-fail; false; \
	  fi \
	fi

LIBRARY_OBJS = mtcp.o mtcp_restart_nolibc.o \
	mtcp_maybebpt.o mtcp_find_executable.o mtcp_printf.o mtcp_readhexetc.o \
	mtcp_safemmap.o mtcp_safe_open.o \
	mtcp_state.o mtcp_check_vdso.o mtcp_sigaction.o mtcp_ptrace.o

# for libtools -- not used
%.lo : %.c
	libtool --mode=compile gcc -c $(CFLAGS) $<

libmtcp.so: mtcp.t ${LIBRARY_OBJS}
	##ld -shared -Map mtcp.map -o libmtcp.so mtcp.lo mtcp_restart_nolibc.lo --verbose
	#   this gets a default .t file so it can be chopped up
	echo LD $(LD)
	echo LDFLAGS $(LDFLAGS)
	${LD} ${LDFLAGS} -T mtcp.t -Wl,-Map,mtcp.map -o libmtcp.so \
	  ${LIBRARY_OBJS} -ldl -lpthread

mtcp.o: mtcp.c mtcp.h mtcp_internal.h mtcp_ptrace.h mtcp_ptrace.o
	${CC} $(CFLAGS) -Wa,-adhl=mtcp.lis -c -o mtcp.o mtcp.c

# Use uname instead of ${UNAME} below to determine if this is really 64-bit.
mtcp_restart_nolibc.o: mtcp_restart_nolibc.c mtcp.h mtcp_internal.h
	if  ${CC} -v --help 2>&1 | grep stack-protector > /dev/null; then \
	  cflags_extra=-fno-stack-protector ; \
	fi; \
	if test ${BUILDTYPE} = x86_64; then \
	  if uname -a | grep '2\.6\.9.*x86_64' > /dev/null; then \
	    cflags_extra="-DBUG_64BIT_2_6_9 $$cflags_extra"; \
	  fi; \
	fi; \
	echo cflags_extra='"'$$cflags_extra'"'; \
	${CC} $(CFLAGS) $$cflags_extra -c -o mtcp_restart_nolibc.o mtcp_restart_nolibc.c;

# mtcp.lis is needed only for debugging.
mtcp.lis: mtcp.c mtcp.h mtcp_internal.h
	${CC} $(CFLAGS) -c -o /dev/null -Wa,-ahls=mtcp.lis mtcp.c

# The resultant mtcp_restart_nolibc.o module should not have undefined symbols
# ... if it did, they would get linked to /lib/libc.so at runtime and 
# ... the restart wouldn't work as /lib/libc.so isn't in memory
#   during the restart
# It also cannot have global symbols like 'read' undefined in one module, defined 
# ... by another, as the loader will also re-direct those references to /lib/libc.so


mtcp_maybebpt.o: mtcp_maybebpt.c mtcp_internal.h
	${CC} $(CFLAGS) -c -o mtcp_maybebpt.o mtcp_maybebpt.c

mtcp_find_executable.o: mtcp_find_executable.c mtcp_internal.h
	${CC} $(CFLAGS) -c -o mtcp_find_executable.o mtcp_find_executable.c

mtcp_safe_open.o: mtcp_safe_open.c mtcp_internal.h
	${CC} $(CFLAGS) -c -o mtcp_safe_open.o mtcp_safe_open.c

mtcp_printf.o: mtcp_printf.c mtcp_internal.h
	if  ${CC} -v --help 2>&1 | grep stack-protector > /dev/null; then \
	  ${CC} $(CFLAGS) -fno-stack-protector -c -o mtcp_printf.o \
	    mtcp_printf.c; \
	else \
	  ${CC} $(CFLAGS) -c -o mtcp_printf.o mtcp_printf.c; \
	fi

mtcp_readhexetc.o: mtcp_readhexetc.c mtcp_internal.h
	${CC} $(CFLAGS) -c -o mtcp_readhexetc.o mtcp_readhexetc.c

mtcp_safemmap.o: mtcp_safemmap.c mtcp_internal.h
	${CC} $(CFLAGS) -c -o mtcp_safemmap.o mtcp_safemmap.c

mtcp_state.o: mtcp_state.c mtcp_internal.h
	${CC} $(CFLAGS) -c -o mtcp_state.o mtcp_state.c

mtcp_state.lis: mtcp_state.c mtcp_internal.h
	${CC} $(CFLAGS) -c -o /dev/null -Wa,-ahls=mtcp_state.lis mtcp_state.c

mtcp_check_vdso.o: mtcp_check_vdso.c
	${CC} $(CFLAGS) -c -o mtcp_check_vdso.o mtcp_check_vdso.c

extractobjectmodule: extractobjectmodule.c
	${CC} $(CFLAGS) -o extractobjectmodule extractobjectmodule.c

mtcp_sigaction.o: mtcp_sigaction.c mtcp_sys.h
	${CC} $(CFLAGS) -c -o mtcp_sigaction.o mtcp_sigaction.c

mtcp_ptrace.o: mtcp_ptrace.c mtcp_internal.h mtcp_ptrace.h
	${CC} $(CFLAGS) -c -o mtcp_ptrace.o mtcp_ptrace.c

dist: distclean
	rm -f /tmp/mtcpv${MTCP_VERSION}
	dir=`pwd`; cd ..; cp -r ./`basename $$dir` /tmp/mtcpv${MTCP_VERSION}; \
	 cd  /tmp; tar czvf mtcpv${MTCP_VERSION}.tgz ./mtcpv${MTCP_VERSION}
	rm -rf /tmp/mtcpv${MTCP_VERSION}
	mv /tmp/mtcpv${MTCP_VERSION}.tgz ../
	ls -l ../mtcpv${MTCP_VERSION}.tgz

# check: default testmtcp
# On recent 32-bit kernels, restart fails in "make", but succeeds manually.
# WHY?
check: libmtcp.so mtcp_restart testmtcp
	@ echo ""
	@ echo Type into program to verify it operates.  Will be killed in 13 s.
	@ echo ""
	(sleep 13; pkill -9 testmtcp) &
	env LD_LIBRARY_PATH=. ./testmtcp || true
	@ echo ""
	@ echo Successfully killed after checkpoint.  Will now restart.
	@ echo Continue typing arbitrary text into program to test that
	@ echo it still works, and that checkpoint of a restart works.
	sleep 5
	./mtcp_restart testmtcp.mtcp
	echo FINISH EARLY FOR NOW
	exit 1
	(sleep 13; pkill -9 mtcp_restart) & ./mtcp_restart testmtcp.tmp || true
	@ echo Kill this program now after being satisfied it still works.
	@ echo ""
	sleep 5
	./mtcp_restart testmtcp.mtcp

distclean: clean
	rm -f *~ mtcp.kdevses mtcp.kdevelop.* testmtcp{,1,2,3,4}.mtcp \
	      *.lis a.out mtcp.t.orig readmtcp

clean:
	rm -f *.o *.map mtcp_restart_noblibc.lis mtcp_sharetemp.c \
	      testmtcp.mtcp libmtcp.so mtcp.t mtcp.t-fail mtcp_restart.so \
	      mtcp_restart extractobjectmodule \

=== debian/changelog ===
dmtcp (1.2.1-2~nd09.10+1) karmic; urgency=low

  * Backported for karmic.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Tue, 31 May 2011 09:05:17 -0400

dmtcp (1.2.1-2) unstable; urgency=low

  * Fixing compilation errors for gcc/g++ 4.6.
  * Fixing compilation errors related to PAGE_SIZE and PAGE_MASK macros.
  * Call "make check" towards the end of build-stamp.
  * Add python to build-deps.
  * Standards Version boosted to 3.9.2.
  * Templates removed from debian/watch.
  * Leading "./" removed from lintian-overrides.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Tue, 31 May 2011 00:17:42 -0400

dmtcp (1.2.1-1) unstable; urgency=low

  * Preparing for upstream release 1.2.1. 

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 12 Mar 2011 17:41:11 -0500

dmtcp (1.2.0+svn937-1) unstable; urgency=low

  * Updating libdmtcpaware1.symbols to reflect the proper version.
  * Updating watch file to point to proper package name

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 12 Mar 2011 17:10:02 -0500

dmtcp (1.2.0+svn923-1) unstable; urgency=low

  * Adding debian/libdmtcpaware1.symbols file.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Wed, 09 Mar 2011 02:03:21 -0500

dmtcp (1.2.0+svn876-1) unstable; urgency=low

  * Initial release (Closes: #610653)
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Thu, 03 Feb 2011 09:52:24 -0500

=== debian/control ===
Source: dmtcp
Section: utils
Priority: optional
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: Kapil Arya <kapil@ccs.neu.edu>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7), python
Standards-Version: 3.9.2
Vcs-svn: https://dmtcp.svn.sourceforge.net/svnroot/dmtcp
Vcs-browser: http://dmtcp.svn.sourceforge.net/viewvc/dmtcp/trunk
Homepage: http://dmtcp.sourceforge.net

Package: dmtcp
Architecture: i386 amd64
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
Description: Checkpoint/Restart functionality for Linux processes
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Windows applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package contains DMTCP binaries.

Package: dmtcp-dbg
Architecture: i386 amd64
Section: debug
Priority: extra
Depends: neurodebian-popularity-contest, dmtcp, ${shlibs:Depends}, ${misc:Depends}
Description: Debug package for dmtcp
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Windows applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package contains debugging symbols for DMTCP.

Package: libdmtcpaware1
Architecture: i386 amd64
Section: libs
Depends: neurodebian-popularity-contest, dmtcp, ${shlibs:Depends}, ${misc:Depends}
Description: DMTCP programming interface
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Windows applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package provides a programming interface to allow checkpointed
 applications to interact with dmtcp.

Package: libdmtcpaware-dev
Architecture: i386 amd64
Section: libdevel
Depends: neurodebian-popularity-contest, libdmtcpaware1 (= ${binary:Version}) , ${shlibs:Depends}, ${misc:Depends}
Description: DMTCP programming interface -- developer package
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Windows applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package provides libraries for developing applications that need to
 interact with dmtcp.

## dmtcp 1.2.4

=== mtcp/Makefile ===
##+++2006-05-03
##    Copyright (C) 2006  Mike Rieker, Beverly, MA USA
##    Additions by Gene Cooperman to work with x86-64 architecture
##    EXPECT it to FAIL when someone's HeALTh or PROpeRTy is at RISk
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; version 2 of the License.
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##---2006-05-03

##########################################################################
##									##
##  Compile and link the shareable, restore utility and test programs	##
##									##
##  Versions tested with:						##
##    binutils-2.15.92, 2.16.1, 2.18.1, 2.19.1				##
##    glibc-2.3.4, 2.3.6, 2.7.12, 2.7, 2.9				##
##    linux-2.6.9-34, 2.6.9-78, 2.6.10, 2.6.14, 2.6.25, 2.6.26		##
##    gcc-3.4.4, 4.0.2, 4.1.3, 4.3.2					##
##									##
##########################################################################

MTCP_VERSION = 77
LIBMTCP_SOVERSION_MAJOR=1
LIBMTCP_SOVERSION_INFO=$(LIBMTCP_SOVERSION_MAJOR).0.0

# EXPERIMENTAL FEATURE:  checkpointing 32-bit images on 64-bit machines:
# Invoke as "make M32=1" to create 32-bit image on 64-bit machine.
# NOTE:  This also requires a modified HIGHEST_VA in mtcp_internal.h.  WHY?

# If we're running under linux32 on a 64-bit O/S, set mixed mode:  M32=1
ifneq (${shell uname -m},x86_64)
ifeq (${shell setarch x86_64 uname -m 2>/dev/null},x86_64)
M32=1
endif
endif

ifdef M32
# HIGHEST_VA is [vdso] (just above [stack])
CC = gcc -m32 -Wa,--32 -DHIGHEST_VA='(VA)0xffffe000'
UNAME = linux32 uname
LD_RAW = ld -m32 -melf_i386
LDFLAGS =  -Wl,-m32 -Wl,-melf_i386 -shared
AS = as
else
CC = gcc
UNAME = uname
LD_RAW = ld
LDFLAGS =  -shared
AS = as --32
endif

#Currently sometimes can't link libmtcp.so without CFLAGS=-O0
CFLAGS += -O0 -g
# Use this for standalone MTCP debugging to stderr, or DMTCP debugging to
#   stderr (and to jassertlog.* , if configured with --enable-debug)
#CFLAGS += -O0 -g -DDEBUG -DTIMING -Wall
# Try:  env CFLAGS=-DTEST_FORKED_CHECKPOINTING to CFLAGS  make
#  	 to enable standalone invocation of forked checkpointing.

LDFLAGS += -Wl,-soname,libmtcp.so.$(LIBMTCP_SOVERSION_MAJOR)

# If calling 'make' from mtcp subdir, you may want to unconditionally set this.
ifdef HBICT_DELTACOMP
  CFLAGS += -DHBICT_DELTACOMP
endif

# If ./configure --enable-fast-ckpt-restart defined, DMTCP 'make' will set this.
# If building MTCP standalone, change the line below to invoke this option.
ifdef FAST_CKPT_RESTART
  CFLAGS += -DFAST_CKPT_RST_VIA_MMAP
endif

ifdef DMTCP_VERSION
  CFLAGS += -DDMTCP_VERSION=\"$(DMTCP_VERSION)\"
endif

LD = ${CC}
OBJCOPY = objcopy
ASFLAGS =
MTCP_DIR := $(shell pwd)

# There might be a 32-bit built system running on top of 32/64 bit capable
# kernel. In that case `uname -m` returns 'x86_64' which is not correct.
# Instead, we should deduce the build-type from the build toochain itself.
ifeq (${shell ${LD_RAW} -shared -verbose|grep OUTPUT_FORMAT|cut -d '"' -f2},elf64-x86-64)
  BUILDTYPE=x86_64
else
  BUILDTYPE=i386
endif

# But for testmtcp, don't use CFLAGS if don't want position-independent code
ifeq ($(BUILDTYPE),x86_64)
  CFLAGS += -fPIC -DPIC
  LDFLAGS += -fPIC 
endif

ifeq ($(shell ${CC} -v --help 2>&1 | grep stack-protector|head -1|wc -l), 1)
  CFLAGS+=-fno-stack-protector
endif

ifdef PREFIX
  bindir=$(PREFIX)/bin
  libdir=$(PREFIX)/lib
  includedir=$(PREFIX)/include
endif

install-error-msg="\
Error: PREFIX or bindir/libdir/includedir not defined \n\
 USAGE:\n\
\tmake [DESTDIR=<destdir>] PREFIX=<path> install\n\
\tmake [DESTDIR=<destdir>] bindir=<path1> libdir=<path2> includedir=<path3> install\n"

all default: build tests readmtcp

install: build
	# DMTCP passes bindir, libdir, and includir as make flags
	if test -z "$(bindir)"; then echo -e $(install-error-msg); false; fi
	if test -z "$(libdir)"; then echo -e $(install-error-msg); false; fi
	if test -z "$(includedir)"; then echo -e $(install-error-msg); false; fi
	test -e $(DESTDIR)$(bindir) || mkdir -p $(DESTDIR)$(bindir)
	test -e $(DESTDIR)$(libdir) || mkdir -p $(DESTDIR)$(libdir)
	test -e $(DESTDIR)$(includedir) || mkdir -p $(DESTDIR)$(includedir)
	cp mtcp_restart $(DESTDIR)$(bindir)
	cp mtcp.h $(DESTDIR)$(includedir)
	cp libmtcp.so.$(LIBMTCP_SOVERSION_INFO) $(DESTDIR)$(libdir)
	cd $(DESTDIR)$(libdir) && ln -sf libmtcp.so.$(LIBMTCP_SOVERSION_INFO) \
	                                 libmtcp.so.$(LIBMTCP_SOVERSION_MAJOR)
	cd $(DESTDIR)$(libdir) && ln -sf libmtcp.so.$(LIBMTCP_SOVERSION_MAJOR) \
					 libmtcp.so
	chmod -f 755 $(DESTDIR)$(libdir)/libmtcp.so*

uninstall:
	rm -f "$(DESTDIR)$(bindir)/mtcp_restart"
	rm -f "$(DESTDIR)$(includedir)/mtcp.h"
	rm -f "$(DESTDIR)$(libdir)"/libmtcp.so*

ifdef FAST_CKPT_RESTART
readmtcp: readmtcp.c mtcp_internal.h libmtcp.so mtcp_util.o \
	mtcp_printf.o mtcp_state.o mtcp_fastckpt.o mtcp_safemmap.o
	${CC} ${CFLAGS} -o readmtcp readmtcp.c $$PWD/libmtcp.so mtcp_util.o \
	  mtcp_printf.o mtcp_state.o mtcp_fastckpt.o mtcp_safemmap.o
else
readmtcp: readmtcp.c mtcp_internal.h
	${CC} ${CFLAGS} -o readmtcp readmtcp.c
endif

build: libmtcp.so mtcp_restart
# Don't do bigtestmtcp by default; Good for stress testing, but slow.
tests: build testmtcp testmtcp2 testmtcp3 testmtcp4 testmtcp5 threadtest

# Test programs

testmtcp: testmtcp.o libmtcp.so
	env LD_LIBRARY_PATH=. ${CC} $(CFLAGS) -o testmtcp testmtcp.o -Wl,--export-dynamic libmtcp.so
	# libtool --mode=link gcc -o testmtcp testmtcp.o -Wl,--export-dynamic libmtcp.so

bigtestmtcp: bigtestmtcp.o libmtcp.so
	env LD_LIBRARY_PATH=. ${CC} $(CFLAGS) -o bigtestmtcp bigtestmtcp.o -Wl,--export-dynamic libmtcp.so

testgettimeofday: testgettimeofday.o libmtcp.so
	env LD_LIBRARY_PATH=. ${CC} $(CFLAGS) \
	  -o testgettimeofday testgettimeofday.o -Wl,--export-dynamic libmtcp.so
testgettimeofday.o: testgettimeofday.c
	${CC} $(CFLAGS) -c -o testgettimeofday.o testgettimeofday.c
checkgettimeofday: libmtcp.so mtcp_restart testgettimeofday
	(sleep 5; pkill testgettimeofda) &
	env LD_LIBRARY_PATH=. ./testgettimeofday || true
	@ echo ""
	@ echo Successfully killed after checkpoint.  Will now restart.
	sleep 2
	(sleep 5; pkill mtcp_restart) &
	./mtcp_restart testgettimeofday.mtcp || true
	@ echo Kill this program now after being satisfied it still works.
	@ echo ""
	sleep 2
	./mtcp_restart testgettimeofday.mtcp

testmtcp.o: testmtcp.c
	${CC} $(CFLAGS) -c -o testmtcp.o testmtcp.c

testmtcp2: testmtcp2.c libmtcp.so
	${CC} $(CFLAGS) -o testmtcp2 testmtcp2.c libmtcp.so

testmtcp3: testmtcp3.c libmtcp.so
	${CC} $(CFLAGS) -o testmtcp3 testmtcp3.c libmtcp.so -lpthread -Xlinker -Map -Xlinker testmtcp3.map

testmtcp4: testmtcp4.c libmtcp.so
	${CC} $(CFLAGS) -o testmtcp4 testmtcp4.c libmtcp.so -lpthread -Xlinker -Map -Xlinker testmtcp4.map

testmtcp5: testmtcp5.c libmtcp.so
	${CC} $(CFLAGS) -o testmtcp5 testmtcp5.c libmtcp.so 

testmtcp6: testmtcp6.c libmtcp.so
	${CC} $(CFLAGS) -Wl,--export-dynamic -o testmtcp6 testmtcp6.c libmtcp.so \
	  -lreadline -lhistory -lcurses

threadtest: threadtest.c
	${CC} $(CFLAGS) -o threadtest threadtest.c

# This is the command-line utility to restore a process
# NOTE: Compile/build mtcp_restart with -nodefaultlibs. See the following
#       explanation.
# RedHat doesn't provide the static libc in their standard
# repository. We want to have mtcp_restart statically linked for the sake
# of VDSO placement and ASLR. Thus we decided to remove the dependency of
# mtcp_restart on libc by rewriting some glibc function calls and
# replacing the glibc-syscall wrappers with the respective mtcp_sys_XXX()
# version.

mtcp_restart: mtcp_restart.c mtcp_internal.h \
	mtcp_printf.o mtcp_util.o mtcp_maybebpt.o \
	mtcp_safemmap.o mtcp_state.o mtcp_safe_open.o \
	mtcp_check_vdso.o mtcp_fastckpt.o
	${CC} $(CFLAGS) -static -nodefaultlibs \
	 -o mtcp_restart mtcp_restart.c mtcp_maybebpt.o \
	 mtcp_printf.o mtcp_util.o mtcp_safemmap.o \
	 mtcp_state.o mtcp_safe_open.o mtcp_check_vdso.o mtcp_fastckpt.o
	 # -lpthread

#not used:
# # mtcp_restart.so is used only by dmtcp --- not by mtcp
# mtcp_restart.so: mtcp_restart.c mtcp_internal.h mtcp_maybebpt.o \
#   mtcp_printf.o mtcp_safe_open.o mtcp_util.o mtcp_safemmap.o mtcp_state.o
# 	# ${CC} $(CFLAGS) -shared -Wl,--no-allow-shlib-undefined
# 	${CC} $(CFLAGS) -shared \
# 	 -o mtcp_restart.so mtcp_restart.c mtcp_maybebpt.o \
# 	 mtcp_printf.o mtcp_util.o mtcp_safemmap.o mtcp_state.o \
# 	 mtcp_safe_open.o

# This is the shareable that a user links with the application

# mtcp.t originally generated as below via:  ld -shared --verbose.
# It was modified to include shareable_begin/end sections.
# The patch was then created with:  diff -c mtcp.t mtcp.tnew > mtcp.t.patch
# Do not replace ld by ${LD} ${LDFLAGS} in generating mtcp.t.
mtcp.t: mtcp.t.patch-i386 mtcp.t.patch-x86_64
	rm -f mtcp.t
	${LD_RAW} -shared --verbose > mtcp.t
	sed -i -e '1,/========================/ d' mtcp.t
	sed -i -e '/========================/,$$ d' mtcp.t
	rm -f mtcp.t-fail
	if test ${BUILDTYPE} = x86_64; then \
	  if patch mtcp.t mtcp.t.patch-x86_64; then \
	    :; \
	  else \
	    mv mtcp.t mtcp.t-fail; false; \
	  fi \
	else \
	  if patch mtcp.t mtcp.t.patch-i386; then \
	    :; \
	  else \
	    mv mtcp.t mtcp.t-fail; false; \
	  fi \
	fi

LIBRARY_OBJS = mtcp.o mtcp_restart_nolibc.o \
	mtcp_maybebpt.o mtcp_printf.o mtcp_util.o \
	mtcp_safemmap.o mtcp_safe_open.o \
	mtcp_state.o mtcp_check_vdso.o mtcp_sigaction.o mtcp_fastckpt.o

# for libtools -- not used
%.lo : %.c
	libtool --mode=compile gcc -c $(CFLAGS) $<

libmtcp.so: mtcp.t ${LIBRARY_OBJS}
	##ld -shared -Map mtcp.map -o libmtcp.so mtcp.lo mtcp_restart_nolibc.lo --verbose
	#   this gets a default .t file so it can be chopped up.
	# mtcp.t adds two sections to mark begin/end of libmtcp.so text/data.
	#   --no-gc-sections, --no-strip-discarded in case default options
	#   want to garbage collection the MTCP sections, and strip its symbols
	echo LD $(LD)
	echo LDFLAGS $(LDFLAGS)
	${LD} ${LDFLAGS} -T mtcp.t -Wl,-Map,mtcp.map \
	  -Wl,--no-gc-sections -Wl,--no-strip-discarded \
	  -o libmtcp.so.$(LIBMTCP_SOVERSION_INFO) ${LIBRARY_OBJS} -ldl -lpthread
	ln -sf libmtcp.so.1.0.0 libmtcp.so.1
	ln -sf libmtcp.so.1 libmtcp.so
	# We need to set ALLOC, or 'eu-strip --remove-comment' will strip our
	# section on Red Hat-based machines w/ debuginfo repository.
	# Redirect stderr to suppress warning that section is not in a segment.
	# (Warning caused by ALLOC section outside of normal .data section.)
	#In SUSE LINUX 10.0 (i586) OSS, we need to back up the libmtcp.so,
	# since objcopy fails, and also corrupts libmtcp.so.
	cp ./libmtcp.so.$(LIBMTCP_SOVERSION_INFO) ./libtmp.so
	${OBJCOPY} --set-section-flags=.the.begin=LOAD,ALLOC,CONTENTS,DATA \
	  ./libmtcp.so.$(LIBMTCP_SOVERSION_INFO) 2>/dev/null || \
	  echo MTCP: Warning: "'${OBJCOPY}'" failed. && \
	  cp ./libtmp.so ./libmtcp.so.$(LIBMTCP_SOVERSION_INFO)
	${OBJCOPY} --set-section-flags=.the.end=LOAD,ALLOC,CONTENTS,DATA \
	  ./libmtcp.so.$(LIBMTCP_SOVERSION_INFO) 2>/dev/null || \
	  echo MTCP: Warning: "'${OBJCOPY}'" failed. && \
	  cp ./libtmp.so ./libmtcp.so.$(LIBMTCP_SOVERSION_INFO)
	rm -f ./libtmp.so
	@nm -D libmtcp.so.$(LIBMTCP_SOVERSION_INFO) | grep ' [BTD] ' | \
	  grep -v ' d\?mtcp_' | \
	  grep -v clone | grep -v '_fini\|init' | grep ' [BTD] ' 1>&2 && \
	  echo '*** WARNING: libmtcp.so.$(LIBMTCP_SOVERSION_INFO): ' \
	       'MTCP symbols polluting user namespace' 1>&2 || true

mtcp.o: mtcp.c mtcp.h mtcp_internal.h
	${CC} $(CFLAGS) -Wa,-adhl=mtcp.lis -c -o mtcp.o mtcp.c

=== test/module/example-db/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting library will have this name.
LIBNAME=dmtcp_${NAME}hijack

# As you add new files to your hijack library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_SRC=${DMTCP_ROOT}/dmtcp/src

CFLAGS += -I${DMTCP_SRC} -DDMTCP -fPIC -c --std=gnu99 -g
CXXFLAGS += -I${DMTCP_SRC} -DDMTCP -fPIC -c -g

DEMO_PORT=7781

default: ${LIBNAME}.so

# We run two processes, dmtcp1, with keys set to 1 for one, and 2 for the other
${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
check: ${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1
	${DMTCP_ROOT}/bin/dmtcp_coordinator --port ${DEMO_PORT} \
	  --background --exit-on-last -i 5
	EXAMPLE_DB_KEY=1 EXAMPLE_DB_KEY_OTHER=2 \
	  ${DMTCP_ROOT}/bin/dmtcp_checkpoint --port ${DEMO_PORT} --join -i 5 \
	  --with-module $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1 &
	EXAMPLE_DB_KEY=2 EXAMPLE_DB_KEY_OTHER=1 \
	  ${DMTCP_ROOT}/bin/dmtcp_checkpoint --port ${DEMO_PORT} --join -i 5 \
	  --with-module $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1 &
	sleep 20; ${DMTCP_ROOT}/bin/dmtcp_command --port ${DEMO_PORT} --quit

# We link the library using C++ for compatibility with the main dmtcphijack.so
${LIBNAME}.so: ${LIBOBJS}
	${CXX} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean:
	rm -f ${LIBOBJS}

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== test/module/sleep1/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting library will have this name.
LIBNAME=dmtcp_${NAME}hijack

# As you add new files to your hijack library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_SRC=${DMTCP_ROOT}/dmtcp/src

CFLAGS += -I${DMTCP_SRC} -DDMTCP -fPIC -c --std=gnu99 -g
CXXFLAGS += -I${DMTCP_SRC} -DDMTCP -fPIC -c -g

DEMO_PORT=7781

default: ${LIBNAME}.so

${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
check: ${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1
	${DMTCP_ROOT}/bin/dmtcp_checkpoint --port ${DEMO_PORT} -i 5 \
	  --with-module $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1

# We link the library using C++ for compatibility with the main dmtcphijack.so
${LIBNAME}.so: ${LIBOBJS}
	${CXX} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean:
	rm -f ${LIBOBJS}

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== test/module/sleep2/Makefile ===
# MOST Makefile's IN ../module/* ARE IDENTICAL.  THIS ONE IS SLIGHTLY ALTERED.
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting library will have this name.
LIBNAME=dmtcp_${NAME}hijack

# As you add new files to your hijack library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_SRC=${DMTCP_ROOT}/dmtcp/src

CFLAGS += -I${DMTCP_SRC} -DDMTCP -fPIC -c --std=gnu99 -g
CXXFLAGS += -I${DMTCP_SRC} -DDMTCP -fPIC -c -g

DEMO_PORT=7781

default: ${LIBNAME}.so

${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
../sleep1/dmtcp_sleep1hijack.so: ../sleep1
	cd ../sleep1; make dmtcp_sleep1hijack.so
check: ${LIBNAME}.so ../sleep1/dmtcp_sleep1hijack.so ${DMTCP_ROOT}/test/dmtcp1
	${DMTCP_ROOT}/bin/dmtcp_checkpoint --port ${DEMO_PORT} -i 5 \
	  --with-module \
		$$PWD/../sleep1/dmtcp_sleep1hijack.so:$$PWD/${LIBNAME}.so \
	  ${DMTCP_ROOT}/test/dmtcp1

# We link the library using C++ for compatibility with the main dmtcphijack.so
${LIBNAME}.so: ${LIBOBJS}
	${CXX} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean:
	rm -f ${LIBOBJS}

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== debian/changelog ===
dmtcp (1.2.4-1~nd50+1) lenny; urgency=low

  * Backported for lenny.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Mon, 13 Feb 2012 22:38:30 -0500

dmtcp (1.2.4-1) unstable; urgency=low

  * Preparing for upstream Release 1.2.4.
  * New binary packages libmtcp1 and libmtcp1-dev created.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Mon, 24 Jan 2012 17:00:11 -0500

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 Package: dmtcp
 Architecture: i386 amd64
-Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
+Depends: neurodebian-popularity-contest, libmtcp1, ${shlibs:Depends}, ${misc:Depends}
 Description: Checkpoint/Restart functionality for Linux processes
  DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
  checkpointing the state of an arbitrary group of programs including
@@ -22,7 +22,7 @@
  Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
  and many programming languages and shell scripting languages.  DMTCP also
  supports GNU screen sessions, including vim/cscope and emacs. With the use of
- TightVNC, it can also checkpoint and restart X-Windows applications, as long
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
  as they do not use extensions (e.g.: no OpenGL, no video).
  .
  This package contains DMTCP binaries.
@@ -31,7 +31,7 @@
 Architecture: i386 amd64
 Section: debug
 Priority: extra
-Depends: neurodebian-popularity-contest, dmtcp, ${shlibs:Depends}, ${misc:Depends}
+Depends: neurodebian-popularity-contest, dmtcp, ${misc:Depends}
 Description: Debug package for dmtcp
  DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
  checkpointing the state of an arbitrary group of programs including
@@ -41,10 +41,48 @@
  Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
  and many programming languages and shell scripting languages.  DMTCP also
  supports GNU screen sessions, including vim/cscope and emacs. With the use of
- TightVNC, it can also checkpoint and restart X-Windows applications, as long
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
  as they do not use extensions (e.g.: no OpenGL, no video).
  .
  This package contains debugging symbols for DMTCP.
+
+Package: libmtcp1
+Architecture: i386 amd64
+Section: libs
+Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
+Suggests: dmtcp
+Description: DMTCP library needed for checkpointing a standalone process
+ DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
+ checkpointing the state of an arbitrary group of programs including
+ multi-threaded and distributed computations.  It operates directly on the user
+ binary executable, with no Linux kernel modules or other kernel mods.
+ .
+ Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
+ and many programming languages and shell scripting languages.  DMTCP also
+ supports GNU screen sessions, including vim/cscope and emacs. With the use of
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
+ as they do not use extensions (e.g.: no OpenGL, no video).
+ .
+ This package provides libmtcp which is needed by DMTCP to checkpoint a single
+ standalone process.
+
+Package: libmtcp-dev
+Architecture: i386 amd64
+Section: libdevel
+Depends: neurodebian-popularity-contest, libmtcp1 (= ${binary:Version}), ${misc:Depends}
+Description: Developer package for libmtcp
+ DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
+ checkpointing the state of an arbitrary group of programs including
+ multi-threaded and distributed computations.  It operates directly on the user
+ binary executable, with no Linux kernel modules or other kernel mods.
+ .
+ Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
+ and many programming languages and shell scripting languages.  DMTCP also
+ supports GNU screen sessions, including vim/cscope and emacs. With the use of
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
+ as they do not use extensions (e.g.: no OpenGL, no video).
+ .
+ This package provides header files needed for building programs with libmtcp.
 
 Package: libdmtcpaware1
 Architecture: i386 amd64
@@ -59,7 +97,7 @@
  Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
  and many programming languages and shell scripting languages.  DMTCP also
  supports GNU screen sessions, including vim/cscope and emacs. With the use of
- TightVNC, it can also checkpoint and restart X-Windows applications, as long
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
  as they do not use extensions (e.g.: no OpenGL, no video).
  .
  This package provides a programming interface to allow checkpointed
@@ -68,7 +106,7 @@
 Package: libdmtcpaware-dev
 Architecture: i386 amd64
 Section: libdevel
-Depends: neurodebian-popularity-contest, libdmtcpaware1 (= ${binary:Version}) , ${shlibs:Depends}, ${misc:Depends}
+Depends: neurodebian-popularity-contest, libdmtcpaware1 (= ${binary:Version}), ${misc:Depends}
 Description: DMTCP programming interface -- developer package
  DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
  checkpointing the state of an arbitrary group of programs including
@@ -78,7 +116,7 @@
  Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
  and many programming languages and shell scripting languages.  DMTCP also
  supports GNU screen sessions, including vim/cscope and emacs. With the use of
- TightVNC, it can also checkpoint and restart X-Windows applications, as long
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
  as they do not use extensions (e.g.: no OpenGL, no video).
  .
  This package provides libraries for developing applications that need to
